VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDate"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Public Enum DateMaskType
    ShortDate = 0
    MedDate = 1
    LongDate = 2
End Enum

Private intDateTypeMask As Integer
Private strMonthFormat(2) As String
Private strDayFormat(2) As String

Public Property Get DateTypeMask() As DateMaskType
    DateTypeMask = intDateTypeMask
End Property

Public Property Let DateTypeMask(ByVal Value As DateMaskType)
    intDateTypeMask = Value
End Property
Private Sub Class_Initialize()
    strMonthFormat(0) = "MM/"
    strMonthFormat(1) = "MMM "
    strMonthFormat(2) = "MMMM "
    strDayFormat(0) = "DD/"
    strDayFormat(1) = "DD, "
    strDayFormat(2) = "DD, "
End Sub

Public Function Mask(intKeyAscii As Integer, strCurrentText As String) As String
    Dim intTemp As Integer
    Select Case Len(strCurrentText)
        Case 0, 1, 2
            If intKeyAscii = vbKeyBack Then
                Mask = ""
            Else
                Mask = FinishMonth(strCurrentText & Chr(intKeyAscii))
            End If
        Case 3  'should only be here with short dates
            If intDateTypeMask > 0 Then 'an error occured erase everything and start over
                Mask = ""
            ElseIf intKeyAscii = vbKeyBack Then
                Mask = ""
            ElseIf intKeyAscii < 48 Or intKeyAscii > 57 Then
                Mask = strCurrentText
            Else
                Mask = FinishDay((Val(Left(strCurrentText, 2))), Val(Chr(intKeyAscii)))
            End If
        Case 4
            If intDateTypeMask = 0 Then 'short date
                intTemp = Val(Left(strCurrentText, 2))
                If intKeyAscii = vbKeyBack Then
                    Mask = Left(strCurrentText, 3)
                ElseIf intKeyAscii < 48 Or intKeyAscii > 57 Then
                    Mask = strCurrentText
                Else
                    Mask = FinishDay(intTemp, Val(Mid(strCurrentText, 4, 1)), Val(Chr(intKeyAscii)))
                End If
            Else    'med date or long and month of May
                intTemp = Month(Left(strCurrentText, 3) & " 01,2000")
                If (intDateTypeMask = 2) And intTemp <> 5 Then  'an error occured erase everything and start over
                    Mask = ""
                ElseIf intKeyAscii = vbKeyBack Then
                    Mask = ""
                ElseIf intKeyAscii < 48 Or intKeyAscii > 57 Then
                    Mask = strCurrentText
                Else
                    Mask = FinishDay(intTemp, Val(Chr(intKeyAscii)))
                End If
            End If
        Case 5  'should only be here for med and long dates
            If intDateTypeMask = 0 Then 'an error occured erase everything and start over
                Mask = ""
            ElseIf intDateTypeMask = 1 Then 'med date
                intTemp = Month(Left(strCurrentText, 3) & " 01,2000")
                If intKeyAscii = vbKeyBack Then
                    Mask = Left(strCurrentText, 4)
                ElseIf intKeyAscii < 48 Or intKeyAscii > 57 Then
                    Mask = strCurrentText
                Else
                    Mask = FinishDay(intTemp, Val(Mid(strCurrentText, 5, 1)), Val(Chr(intKeyAscii)))
                End If
            Else    'long date
                intTemp = Month(Left(strCurrentText, 3) & " 01,2000")
                If intTemp <> 5 And intTemp <> 6 And intTemp <> 7 Then  'an error has occured erase it all and start over
                    Mask = ""
                ElseIf intKeyAscii = vbKeyBack Then
                    If intTemp = 5 Then
                        Mask = Left(strCurrentText, 4)
                    Else
                        Mask = ""
                    End If
                ElseIf intKeyAscii < 48 Or intKeyAscii > 57 Then
                    Mask = strCurrentText
                ElseIf intTemp = 5 Then 'long month of may
                    Mask = FinishDay(5, Val(Mid(strCurrentText, 5, 1)), Val(Chr(intKeyAscii)))
                ElseIf (intTemp = 6) Or (intTemp = 7) Then 'long month of june and july
                    Mask = FinishDay(intTemp, Val(Chr(intKeyAscii)))
                Else
                    Mask = strCurrentText
                End If
            End If
        Case 6  'six characters exist
            If intDateTypeMask = 1 Then 'an error occured erase everything and start over
                Mask = ""
            ElseIf intDateTypeMask = 0 Then 'Short Date
                If intKeyAscii = vbKeyBack Then
                    Mask = Left(strCurrentText, 3)
                ElseIf (intKeyAscii < 48) Or (intKeyAscii > 57) Then
                    Mask = strCurrentText
                Else
                    Mask = strCurrentText & Chr(intKeyAscii)
                End If
            Else    'long date
                intTemp = Month(Left(strCurrentText, 3) & " 01,2000")
                If intKeyAscii = vbKeyBack Then
                    If intTemp = 6 Or intTemp = 7 Then
                        Mask = Left(strCurrentText, 5)
                    Else    'an error occured erase everything and start over
                        'also erase everything if it is march or april
                        Mask = ""
                    End If
                ElseIf (intKeyAscii < 48) Or (intKeyAscii > 57) Then
                    Mask = strCurrentText
                Else
                    If intTemp = 3 Or intTemp = 4 Then  'mar or apr
                        Mask = FinishDay(intTemp, Val(Chr(intKeyAscii)))
                    ElseIf intTemp = 6 Or intTemp = 7 Then  'jun or jul
                        Mask = FinishDay(intTemp, Val(Mid(strCurrentText, 6, 1)), Val(Chr(intKeyAscii)))
                    Else    'an error occured erase everything and start over
                        Mask = ""
                    End If
                End If
            End If
        Case 7  'seven characters exist
            If intDateTypeMask = 1 Then 'an error occured erase everything and start over
                Mask = ""
            ElseIf intDateTypeMask = 0 Then 'short date
                If intKeyAscii = vbKeyBack Then
                    Mask = Left(strCurrentText, 6)
                ElseIf (intKeyAscii < 48) Or (intKeyAscii > 57) Then
                    Mask = strCurrentText
                Else
                    Mask = FinishYear(Val(Left(strCurrentText, 2)), Val(Mid(strCurrentText, 4, 2)), Val(Mid(strCurrentText, 7, 1)), Val(Chr(intKeyAscii)))
                End If
            Else    'long date
                intTemp = Month(Left(strCurrentText, 3) & " 01,2000")
                If intKeyAscii = vbKeyBack Then
                    If intTemp = 3 Or intTemp = 4 Then
                        Mask = Left(strCurrentText, 6)
                    Else    'either an error occured or it's the month of august
                        Mask = ""
                    End If
                ElseIf (intKeyAscii < 48) Or (intKeyAscii > 57) Then
                    Mask = strCurrentText
                Else    'valid key was pressed
                    If intTemp = 3 Or intTemp = 4 Then  'march or april
                        Mask = FinishDay(intTemp, Val(Mid(strCurrentText, 7, 1)), Val(Chr(intKeyAscii)))
                    ElseIf intTemp = 8 Then 'august
                        If (intKeyAscii < 48) Or (intKeyAscii > 57) Then
                            Mask = strCurrentText
                        Else
                            Mask = FinishDay(8, Val(Chr(intKeyAscii)))
                        End If
                    Else    'an error occured erase everything and start over
                        Mask = ""
                    End If
                End If
            End If
        Case 8  'eight characters
            If intDateTypeMask = 0 Then 'short date
                If intKeyAscii = vbKeyBack Then
                    Mask = Left(strCurrentText, 7)
                ElseIf intKeyAscii < 48 Or intKeyAscii > 57 Then
                    Mask = strCurrentText
                Else
                    Mask = strCurrentText & Chr(intKeyAscii)
                End If
            ElseIf intDateTypeMask = 1 Then 'med date
                If intKeyAscii = vbKeyBack Then
                    Mask = Left(strCurrentText, 4)
                ElseIf (intKeyAscii < 48) Or (intKeyAscii > 57) Then
                    Mask = strCurrentText
                Else
                    Mask = strCurrentText & Chr(intKeyAscii)
                End If
            Else    'long date
                intTemp = Month(Left(strCurrentText, 3) & " 01,2000")
                If intKeyAscii = vbKeyBack Then
                    If intTemp = 5 Then 'may
                        Mask = Left(strCurrentText, 5)
                    ElseIf intTemp = 8 Then 'august
                        Mask = "August "
                    Else    'an error occured or it's months Jan or Oct; erase everything
                        Mask = ""
                    End If
                ElseIf (intKeyAscii < 48) Or (intKeyAscii > 57) Then
                    Mask = strCurrentText
                Else
                    Select Case intTemp
                        Case 1, 5, 10  'jan, may or  oct
                            If intKeyAscii > 51 And intTemp <> 5 Then
                                Mask = Format(strCurrentText & "0" & Chr(intKeyAscii) & " 2000", "MMMM DD, ")
                            Else
                                Mask = strCurrentText & Chr(intKeyAscii)
                            End If
                        Case 8  'aug
                            If ((Val(Right(strCurrentText, 1)) = 3) And intKeyAscii > 49) Or ((Val(Right(strCurrentText, 1)) = 0) And intKeyAscii = 48) Then
                                Mask = strCurrentText
                            Else
                                Mask = strCurrentText & Chr(intKeyAscii) & ", "
                            End If
                        Case Else   'an error occured erase everything and start over
                            Mask = ""
                    End Select
                End If
            End If
        Case 9  'nine characters
            If intDateTypeMask = 0 Then 'short date
                If intKeyAscii = vbKeyBack Then
                    Mask = Left(strCurrentText, 8)
                ElseIf (intKeyAscii < 48 Or intKeyAscii > 57) Or (Not (IsDate(Format(strCurrentText & Chr(intKeyAscii), "MM/DD/YYYY")))) Then
                    Mask = strCurrentText
                Else
                    Mask = strCurrentText & Chr(intKeyAscii)   'finished with short date
                End If
            ElseIf intDateTypeMask = 1 Then 'med date
                If intKeyAscii = vbKeyBack Then
                    Mask = Left(strCurrentText, 8)
                ElseIf (intKeyAscii < 48 Or intKeyAscii > 57) Then
                    Mask = strCurrentText
                Else
                    Mask = FinishYear(Month(strCurrentText & "000"), Day(strCurrentText & "000"), Val(Mid(strCurrentText, 9, 1)), Val(Chr(intKeyAscii)))
                End If
            Else    'long date
                intTemp = Month(Left(strCurrentText, 3) & " 01,2000")
                If intKeyAscii = vbKeyBack Then
                    If intTemp = 1 Or intTemp = 10 Or intTemp = 5 Then 'jan or oct or may
                        Mask = Left(strCurrentText, Len(strCurrentText) - 1)
                    ElseIf intTemp = 6 Or intTemp = 7 Then  'june or july
                        Mask = Left(strCurrentText, 5)
                    Else    'an error has occured or months nov or dec
                        Mask = ""
                    End If
                ElseIf (intKeyAscii < 48 Or intKeyAscii > 57) Then
                    Mask = strCurrentText
                Else
                    Select Case intTemp
                        Case 1, 10 'jan or oct
                            If (Val(Right(strCurrentText, 1)) = 0 And intKeyAscii = 48) Or (Val(Right(strCurrentText, 1)) = 3 And intKeyAscii > 49) Then
                                Mask = strCurrentText
                            Else
                                Mask = strCurrentText & Chr(intKeyAscii) & ", "
                            End If
                        Case 2  'feb
                            If intKeyAscii > 50 Then
                                Mask = strCurrentText & "0" & Chr(intKeyAscii) & ", "
                            Else
                                Mask = strCurrentText & Chr(intKeyAscii)
                            End If
                        Case 5, 6, 7 'may, june or july
                            If intTemp = 5 Then
                                Mask = FinishYear(intTemp, Val(Mid(strCurrentText, 5, 2)), Val(Right(strCurrentText, 1)), Val(Chr(intKeyAscii)))
                            Else
                                Mask = strCurrentText & Chr(intKeyAscii)
                            End If
                        Case 11, 12 'nov or dec
                            Mask = FinishDay(intTemp, Val(Chr(intKeyAscii)))
                        Case Else   'an error has occured so erase everything
                            Mask = "'"
                    End Select
                End If
            End If
        Case 10 'ten characters
            If intDateTypeMask = 0 Then 'short date...only BS allowed
                If intKeyAscii = vbKeyBack Then
                    Mask = Left(strCurrentText, 9)
                Else
                    Mask = strCurrentText
                End If
            ElseIf intDateTypeMask = 1 Then 'med date
                If intKeyAscii = vbKeyBack Then
                    Mask = Left(strCurrentText, 9)
                ElseIf (intKeyAscii < 48 Or intKeyAscii > 57) Then
                    Mask = strCurrentText
                Else
                    Mask = strCurrentText & Chr(intKeyAscii)
                End If
            Else    'long date
                intTemp = Month(Left(strCurrentText, 3) & " 01,2000")
                If intKeyAscii = vbKeyBack Then
                    Select Case intTemp
                        Case 2, 5, 6, 7, 11, 12 'feb, may, jun, jul, nov, or dec
                            Mask = Left(strCurrentText, Len(strCurrentText) - 1)
                        Case 3, 4   'mar or apr
                            Mask = Left(strCurrentText, 6)
                        Case Else   'error or sept
                            Mask = ""
                    End Select
                ElseIf (intKeyAscii < 48 Or intKeyAscii > 57) Then
                    Mask = strCurrentText
                Else
                    Select Case intTemp
                        Case 2, 11, 12  'feb, nov, dec
                            Mask = FinishDay(intTemp, Val(l(Chr(intKeyAscii)))
                            Else
                  C                N               EA2
      inb Then
                    Mask =        96Ndn                End If
            Else    'long date
                intTemp = Month(Left(strCurrentTexw    Mask = Left(strCurrentTex(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(str(stnsF> U               If intKeyAscii = vbKeyBack Then
                    If intTemp = 5 T= strCurrent7ask = strCurrentText & Chr(intKeyAscii)
                End If
            Else    'long date
                intTemp = Month(Left(strCurrentText, 3) & " 01,2000")
                If intKey00")
                If intKey00")
                If intKey00")
      Text & Chr(i              End IfF    If intKeyAscii                         If intKeyAscii > 51 And intTemp <> 5 Then
          (str(str(str(str(str(str(str(str(str(stk), VText & Chr(8,1
             Else
scih(Lef If intKey00")
    b,8et0      r8     If3t
                            Else
 7cia r Chr(8,1
             Else
scih(Lef If intKey00")
    b,8et0      r8     If3t
                            Else
 7cia r Chr(8,1
             Else
scih(Lef If intKey00")
    b,8et0    ,8et0      r8(str(str(str(str(str(s intKey00")
    b,8et0    ,8et0      r8(str(str(str(str(str(s intKey00")
    b,8et0    ,8et0      r8(str(str(str(str(str(s intKey00")
    b,8et0    ,8et0   r(str(str(str(str8           If intKeyAscii > 51 And intTemp <> 5 Then
          (str(str(str(str(str(str(s  (str(str(00")
0eers exist
            If intDateTypeMask = 1 Then 'an error occured (str(str(str(str(s  (str(str(00")
0eers exisOs Val(Chr(intKeyAscii)))
                 & Chr(intKeyAscii)   'finished wittr(str(str(str(str(str(str(str(str(stk), VText & Chr(8,1
          Etr(str(str(stk), VText & Chr(8,1
          Etr(str(,ask = FinishDay(intTemp, Va